<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <title>Sisplan Web | Relatório de Estoque</title>
  <!-- Tell the browser to be responsive to screen width -->
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=3.241.10.2">

  <link rel="stylesheet" href="dist/css/adminlte.min.css?versao=3.241.10.2">
  <link rel="stylesheet" href="dist/css/custom.css?versao=3.241.10.2">
  <link rel="stylesheet" href="dist/css/sisplan.css?versao=3.241.10.2">
  <link rel="stylesheet" href="dist/css/PesquisaVariosSelect2.css?versao=3.229.22.1">
  <link rel="stylesheet" type="text/css" href="plugins/datatables-keytable/css/keyTable.bootstrap4.min.css?versao=3.241.10.2">
  <link rel="stylesheet" href="plugins/toastr/toastr.min.css?versao=3.241.10.2">
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css?versao=3.241.10.2">
  <link rel="shortcut icon" href="favicon.ico">
  <link rel="stylesheet" type="text/css" href="dist/css/driver.min.css?versao=3.241.10.2" />
  <link rel="stylesheet" href="dist/css/jquery-ui.css?versao=3.241.10.2">
  <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css?versao=3.234.11.1">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css?versao=3.234.11.1">
  <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css?versao=3.236.19.1">
  <link rel="stylesheet" href="plugins/select2/css/select2.min.css?versao=3.234.11.1">
  <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css?versao=3.236.19.1">
  <link rel="stylesheet" href="plugins/datatables-colreorder/css/colReorder.bootstrap4.min.css?versao=3.234.11.1">
  <style>
    .table.dataTable tbody td,
    th {
      white-space: nowrap;
      text-overflow: ellipsis;
      overflow: hidden;
    }

    .border-Field .textoBorda {
      font-size: 1.1em !important;
      text-align: left !important;
      width: auto;
      padding: 0 10px;
      border-bottom: none;
    }

    .border-Field {
      border: 1px solid var(--font-color) !important;
      padding: 0 0.5em 0 0.5em !important;
      margin: 0 0 0 0 !important;
      -webkit-box-shadow: 0px 0px 0px 0px #000;
      box-shadow: 0px 0px 0px 0px #000;
      border-radius: 3px !important;
    }

    .icheck-primary {
      margin-top: 0 !important;
    }
  </style>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <main class="wrapper">

    <?php
    include_once('../../menu.php');
    ?>

    <div class="content-wrapper">
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6 flex">
              <h1 class="m-0 text-dark">Relatório de Estoque de Produto</h1>
              <button type="button" class="btn btn-info btn-sm ml-2" title="Tutorial" style="color: white;" id="tutorial">
                <i class="fas fa-question-circle"></i></button>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="./index">Início</a></li>
                <li class="breadcrumb-item active">Relatório de Estoque de Produto</li>
              </ol>
            </div>
          </div>
          <div class="row">
            <div class="col-12">
              <fieldset>
                <div class="row">
                  <div class="col-12">
                    <div class="buttons">
                      <button class="btn btn-success btn-sisp" id="btnFiltros" type="button"><span class="fas fa-filter"></span> Filtros</button>
                      <button id="btnImprimir" class="btn-sisp btn btn-danger"><i class="fas fa-print"></i> Imprimir</button>
                    </div>
                  </div>
                </div>
                <div class="card-body">
                  <div class="card">
                    <div class="col-sm-12 table-responsive card-body">
                      <table id="tabelaRelEstoque" class="table table-sm table-select table-hover" width="100%"></table>
                      <thead>
                        <tr></tr>
                      </thead>
                      <tbody>
                        <tr></tr>
                      </tbody>
                    </div>
                  </div>
                </div>
              </fieldset>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div id="modal-filtros" class="modal" tabindex="-1" role="dialog">
      <div class="modal-dialog modal-xl" role="document">
        <div class="modal-content" id="modalBody">
          <div class="modal-header">
            <h4 class="modal-title">Filtros
              <!-- <label style="font-size: 60%; padding-top: 25px; min-width: 180px; margin-left: 20px;">
                <input type="checkbox" id="cbContemEstoque">
                <span class="checkmark"></span>
                 Somente c/ Estoque</label> -->
            </h4>
            <div class="form-row ml-4 pt-2">
              <div class="icheck-primary pl-1">
                <input type="checkbox" class="form-check-input" name="cbContemEstoque" id="cbContemEstoque">
                <label class="form-check-label pr-2" for="cbContemEstoque">Somente c/ Estoque</label>
              </div>
            </div>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-body">

            <div class="row mb-2 justify-content-md-start justify-content-center">
              <div class="col-auto ml-2">
                <div class="row">
                  <fieldset class="form border-Field mb-0 pb-0">
                    <legend class="textoBorda mb-0 pb-0">Opções</legend>
                    <div class="">
                      <div class="d-block d-md-flex">
                        <div class="icheck-primary mr-3"><input type="checkbox" class="form-check-input" name="checkRes" id="checkRes"> <label for="checkRes">Descontar Reserva</label></div>
                        <div class="icheck-primary mr-3"><input type="checkbox" class="form-check-input" name="checkExp" id="checkExp"><label for="checkExp">Descontar Expedição</label></div>
                        <div class="icheck-primary mr-3"> <input type="checkbox" class="form-check-input" checked name="checkDep" id="checkDep"><label for="checkDep">Separar Depósitos</label></div>
                        <div class="icheck-primary mr-3"> <input type="checkbox" class="form-check-input" checked name="checkLot" id="checkLot"> <label for="checkLot">Separar Lotes</label></div>
                        <div class="icheck-primary"> <input type="checkbox" class="form-check-input" name="checkTabPrecoCorTam" id="checkTabPrecoCorTam"> <label for="checkTabPrecoCorTam">Tabela de Preço por Cor/Tam</label></div>
                      </div>
                    </div>
                  </fieldset>
                </div>
              </div>
            </div>

            <div class="form-row">
              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" id="labelProduto" for="txtProduto">Produto: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtProduto" name="txtProduto" class="form-control" placeholder="Produto"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtProduto" name="txtProduto" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnProduto" name="btnProduto" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaProduto" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 mudaTamanho form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtCor">Cor: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtCor" name="txtCor" class="form-control" placeholder="Cor"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtCor" name="txtCor" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnCor" name="btnCor" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaCor" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group" id="divTamanho">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtTamanho">Tamanho: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtTamanho" name="txtTamanho" class="form-control" placeholder="Tamanho"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtTamanho" name="txtTamanho" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnTamanho" name="btnTamanho" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaTamanho" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtGrupoPA">Grupo: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtGrupoPA" name="txtGrupoPA" class="form-control" placeholder="GrupoPA"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtGrupoPA" name="txtGrupoPA" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnGrupoPA" name="btnGrupoPA" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaGrupoPA" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group" id="divEtiqueta">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtEtiqueta">Etiqueta: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtEtiqueta" name="txtEtiqueta" class="form-control" placeholder="Etiqueta"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtEtiqueta" name="txtEtiqueta" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnEtiqueta" name="btnEtiqueta" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaEtiqueta" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group" id="divLinha">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtLinha">Linha: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtLinha" name="txtLinha" class="form-control" placeholder="Linha"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtLinha" name="txtLinha" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnLinha" name="btnLinha" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaLinha" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-4 col-sm-6 col-12 mudaTamanho form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtColecao">Coleção: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtColecao" name="txtColecao" class="form-control" placeholder="Coleção"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtColecao" name="txtColecao" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnColecao" name="btnColecao" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaColecao" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12" id="divMarca form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtMarca">Marca: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtMarca" name="txtMarca" class="form-control" placeholder="Marca"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtMarca" name="txtMarca" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnMarca" name="btnMarca" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaMarca" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group" id="divModelo">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtModelo">Modelo: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtModelo" name="txtModelo" class="form-control" placeholder="Modelo"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtModelo" name="txtModelo" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnModelo" name="btnModelo" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaModelo" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtTipoProduto">Tipo de Produto: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <select class="js-example-programmatic js-states form-control" id="txtTipoProduto" name="txtTipoProduto" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnTipoProduto" name="btnTipoProduto" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaTipoProduto" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>

              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtDepositoUsuario">Depósito: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtDepositoUsuario" name="txtDepositoUsuario" class="form-control" placeholder="DepositoUsuario"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtDepositoUsuario" name="txtDepositoUsuario" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnDepositoUsuario" name="btnDepositoUsuario" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaDepositoUsuario" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtQualidade">Qualidade: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <!-- <input type="text" class="input-default focus form-control" id="txtQualidade" name="txtQualidade" class="form-control" placeholder="Qualidade"> -->
                    <select class="js-example-programmatic js-states form-control" id="txtQualidade" name="txtQualidade" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnQualidade" name="btnQualidade" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaQualidade" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <div class="col-md-4 col-sm-6 col-12 form-group">
                <label data-error="wrong" data-success="right" for="txtTabPreco">Tabela: </label>
                <div class="relative">
                  <div class="input-group">
                    <input type="text" class="input-default focus form-control" id="txtTabPreco" class="form-control" placeholder="Tabela">
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnTabPreco" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaTabPreco" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div>
              <!-- <div class="col-md-4 col-sm-6 col-12 mudaTamanho form-group">
                <label style="margin-bottom: .1rem;" data-error="wrong" data-success="right" for="txtTabPreco">Tabela: </label>
                <div class="relative" style="margin-top: 5px;">
                  <div class="input-group">
                    <select class="js-example-programmatic js-states form-control" id="txtTabPreco" name="txtTabPreco" multiple="multiple">
                    </select>
                    <div class="input-group-append">
                      <button class="btn bg-danger" id="btnTabPreco" name="btnTabPreco" data-button="absolute" type="button"><i class="m-0 p-0 fas fa-search"></i></button>
                      <button class="btn bg-danger" id="btnLimpaTabPreco" type="button"><i class="m-0 p-0 fas fa-trash"></i></button>
                    </div>
                  </div>
                </div>
              </div> -->

              <!-- <div class="col-md-6 col-sm-6 col-12 d-none" id="vazio"></div> -->
              <!-- <div class="col-md-4 col-sm-4 col-12 form-group">
                <label style="margin-bottom: .3rem;" data-error="wrong" class="labelGearal" data-success="right" for="txtOrdem">Opção de Relatório: </label>
                <div class="input-group">
                  <select class="input-default focus form-control" data-dropdown-css-class="select2-danger" id="txtOrdem" class="custom-select">
                  </select>
                </div>
              </div> -->
            </div>
          </div>
          <div class="modal-footer">
            <div class="form-row col-12 m-0 p-0">
              <div class="col-md-4 col-sm-4 col-12">
                <label for="txtOrdem">Opção de Relatório:</label>
                <div class="relative">
                  <select id="txtOrdem" class="input-default focus custom-select">
                  </select>
                </div>
              </div>
              <div class="col-md-8 col-sm-8 col-12 d-flex justify-content-end align-items-end pr-0">
                <div class="d-flex">
                  <button class="btn btn-primary btn-sisp mr-2" id="btnLimparFiltros" style="background-color: #B22222; border-color: #B22222">
                    <span class="fas fa-trash"></span> Limpar Filtros
                  </button>
                  <button id="btnConsultar" class="btn btn-primary btn-sisp" type="button">
                    <span class="fas fa-search"></span> Consultar
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside><!-- /.control-sidebar -->
    <?php include_once('../../footer.php'); ?>
  </main><!-- /.wrapper -->

  <script src="plugins/jquery/jquery.min.js?versao=3.241.10.2"></script>
  <script src="dist/js/jquery.maskMoney.min.js?versao=3.241.10.2"></script>
  <script src="plugins/jquery-ui/jquery-ui.min.js?versao=3.241.10.2"></script>
  <script type="text/javascript" src="dist/js/jquery.dataTables.js?versao=3.241.10.2"></script>
  <script type="text/javascript" src="dist/js/dataTables.bootstrap4.min.js?versao=3.241.10.2"></script>
  <script src="plugins/sweetalert2/sweetalert2.min.js?versao=3.241.10.2"></script>
  <script src="plugins/toastr/toastr.min.js?versao=3.241.10.2"></script>
  <script>
    $.widget.bridge('uibutton', $.ui.button);
  </script>
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js?versao=3.241.10.2"></script>
  <script src="dist/js/adminlte.min.js?versao=3.241.10.2"></script>
  <script src="dist/js/requisicoes.js?versao=3.241.10.2"></script>
  <script src="dist/js/loadingoverlay.min.js?versao=3.241.10.2"></script>
  <script src="dist/js/valida_cpf_cnpj.js?versao=3.241.10.2"></script>
  <script src="plugins/jquery-validation/jquery.validate.min.js?versao=3.241.10.2"></script>
  <script src="dist/js/dataTables.keyTable.js?versao=3.241.10.2"></script>
  <script src="dist/js/sisplan.js?versao=3.241.10.2"></script>
  <script src="utils/funcoes.js?versao=3.241.10.2"></script>
  <script src="utils/cookies.js?versao=3.241.10.2"></script>
  <script src="dist/js/driver.min.js?versao=3.241.10.2"></script>
  <script src="config.js?versao=3.241.10.2"></script>
  <script src="plugins/select2/js/select2.full.min.js?versao=3.241.10.2"></script>
  <script src="plugins/datatables-colreorder/js/dataTables.colReorder.min.js?versao=3.241.10.2"></script>
  <script>
    $(document).ready(async function() {
      if (getCookie('usuario') == "") {
        window.location.href = `${BASE_URI}/login`;
        return;
      }

      let usuario = getCookie('usuario');
      let empresa = getCookie('empresa');

      ipInterno = IP_INTERNO;
      ipExterno = IP_EXTERNO;
      basicAuth = BASIC_AUTH;

      const temAcesso = await temAcessoTela('RELESTOQUE');
      if (!temAcesso.resultado) {
        toastrAcesso(temAcesso, BASE_URI);
        return;
      }

      sArquivo = `${BASE_URI}/pages/relestoque/relestoque.js?versao=3.241.10.2`;
      const nomeTela = ('<?php echo basename(__FILE__) ?>').replace('.php', '');
      // nomeTela


      await insereJavaScriptPagina(sArquivo);

      habilitaCamposObrigatoriosTela(nomeTela);
    });
  </script>

</body>

</html>